<?php 
#########################################################################
#                                                                       #
#  ████   ████  █████   ████  █████  ██████  ████  █████   ████   ████  #
# ██  ██ ██  ██ ██  ██   ██   ██  ██ █ ██ █ ██  ██ ██  ██   ██   ██  ██ #
#  ██    ██     ██  ██   ██   ██  ██   ██   ██  ██ ██  ██   ██   ██     #
#   ██   ██     █████    ██   █████    ██   ██  ██ █████    ██   ██     #
#    ██  ██     ██  ██   ██   ██       ██   ██  ██ ██       ██   ██     #
# ██  ██ ██  ██ ██  ██   ██   ██       ██   ██  ██ ██       ██   ██  ██ #
#  ████   ████  ██  ██  ████  ██      ████   ████  ██      ████   ████  #
#                                                                       #
#########################################################################

########################
#                      #
#  ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#   ▒▒   ▒▒▒ ▒▒   ▒▒   #
#   ▒▒   ▒▒▒▒▒▒   ▒▒   #
#   ▒▒   ▒▒ ▒▒▒   ▒▒   #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#  ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                      #
########################

define('VERSION','1.1');
if (!is_dir('rendered')){mkdir('rendered');}
if (!is_dir('scripts')){mkdir('scripts');}


##################################################################
#                                                                #
# ▒▒▒▒▒▒ ▒▒  ▒▒ ▒   ▒▒  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒   ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ ▒ ▒▒ ▒   ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒     ▒▒  ▒▒ ▒▒▒ ▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒ ▒▒  ▒▒    #
# ▒▒▒▒▒  ▒▒  ▒▒ ▒▒▒▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒▒▒▒   ▒▒   #
# ▒▒     ▒▒  ▒▒ ▒▒ ▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒ ▒▒▒    ▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒   ▒▒     ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒      ▒▒▒▒  ▒▒   ▒  ▒▒▒▒   ▒▒▒▒   ▒▒▒▒   ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                                                                #
##################################################################
include('zip_class.php');
include('pictool_class.php');
function zipme($file,$exclude='*\.zip'){
    if (is_file($file)){
        header("Location: ".$file);
        exit;
    }
    $zip=new zip(); 
    $zip->listFiles('./',$exclude);    
    $zip->create('./',$file);
    $zip->download();
    exit;
}
function getURL(){
    $url = @( $_SERVER["HTTPS"] != 'on' ) ? 'http://'.$_SERVER["SERVER_NAME"] : 'https://'.$_SERVER["SERVER_NAME"];
    $url .= dirname($_SERVER["SCRIPT_NAME"]);    
    return $url;
}   

########################
#                      #
#  ▒▒▒▒  ▒▒▒▒▒▒ ▒▒▒▒▒▒ #
# ▒▒  ▒▒ ▒▒     ▒ ▒▒ ▒ #
# ▒▒     ▒▒       ▒▒   #
# ▒▒ ▒▒▒ ▒▒▒▒▒    ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
#  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒  #
#                      #
########################

if (isset($_GET['help'])){	
	exit(nl2br(file_get_contents('readme.html')));
}

if (isset($_GET['version'])){	
	exit(VERSION);
}
if (isset($_GET['download'])){	
	zipme('Scriptopic_v'.VERSION.'.zip','.\.zip|.rendered\/.');
}
if (isset($_GET['picslist'])){
	$picslist=glob('rendered/*');
	if (!isset($_GET['random'])){
		$picslist=array_map('basename',$picslist);		
	}else{
		shuffle($picslist);
		$_GET['random']=intval($_GET['random']);
		if (empty($_GET['random'])){
			exit($picslist[0]);
		}
		$picslist=array_slice($picslist,0, $_GET['random']);
	}
	if (!isset($_GET['gallery'])){
		exit(json_encode($picslist));
	}else{
		echo '<style>img{display:block;width:100%;height:auto;}</style><div style="display:grid;grid-template-columns: repeat(auto-fit, minmax(256px, 1fr));
			">';
		foreach ($picslist as $pic) {
			echo '<img src="rendered/'.$pic.'"/>';
		}
		echo '</div>';
	}
	
}

if (!empty($_GET['i'])&&!empty($_GET['script'])){
	$url=filter_var($_GET['i'],FILTER_SANITIZE_URL);
	$filename=hash('sha1', $_SERVER['QUERY_STRING']).'.jpg';
	$generated_picture_path='rendered/'.$filename;
	# ne pas régénérer les images déjà générées
	if (is_file($generated_picture_path) && !isset($_GET['force'])){
		header ("Content-type: image/jpg");
		exit(file_get_contents($generated_picture_path));
	}

	$script=is_file('scripts/'.$_GET['script'].'.json')?file_get_contents('scripts/'.$_GET['script'].'.json'):$_GET['script'];
	if (!$commands=json_decode($script,true)){
		exit('Incorrect script format');
	}

	$picture=new pictool();
	$picture->load($url);
	foreach ($commands as $array_command) {
		$command=array_keys($array_command)[0];
		$amount=$array_command[$command];
		if (method_exists($picture,$command)){
			if (!is_array($amount)){
				$picture->$command($amount);
			}else{

				if ($command=='text'){
					foreach($amount as $k=>$v){
						if ($k==0){
							$amount[$k]=str_replace(['\n','/n'],"\n",$v);
						}
						if (strpos(' comic,monospace,sans,serif,round ', $v)!==false){
							$amount[$k]='i/'.$v.'.ttf';
						}
					}
				}

				$picture->$command(...$amount);
			}
		}
	}
	if (!isset($_GET['dontsave'])){
		$picture->save($generated_picture_path);
	}
	$picture->display();
}elseif(!empty($_GET['i'])){
	$url=filter_var($_GET['i'],FILTER_SANITIZE_URL);
}else{
	$url='';
}



include('frontend.php');